#include "parse.h"

packet parse_this(char buffer[])
{
	packet p;

	p.ax = (buffer[1] << 8) | buffer[0];
	p.ay = (buffer[3] << 8) | buffer[2];
	p.az = (buffer[5]  << 8)| buffer[4];

	p.gx = (buffer[7]  << 8) | buffer[6];
	p.gy = (buffer[9] << 8)  | buffer[8];
	p.gz = (buffer[11] << 8) | buffer[10];

	p.mx = (buffer[13]  << 8) | buffer[12];
	p.my = (buffer[15]  << 8) | buffer[14];
	p.mz = (buffer[17]  << 8) | buffer[16];

	p.altitude = (buffer[19] << 8) | buffer[18];
	p.heading =  (buffer[21] << 8) | buffer[20];

	for(int i=0;i<8;i++)
	{
		p.servo[i] = buffer[22+i];
		p.motors[i] = buffer[30+i];
		p.rcdata[i] = buffer[38+i];
	}

	return p;
}

void print_struct(packet p)
{
//	if(p.ax)
		rprintf("Accelerometer X-axis: %d \n", p.ax);
//	if(p.ay)
		rprintf("Accelerometer Y-axis: %d \n", p.ay);
//	if(p.az)
		rprintf("Accelerometer Z-axis: %d \n", p.az);
//	if(p.gx)
		rprintf("Gyroscope X-axis: %d \n", p.gx);
//	if(p.gy)
		rprintf("Gyroscope Y-axis: %d \n", p.gy);
//  if(p.gz)
		rprintf("Gyroscope Z-axis: %d \n", p.gz);
//	if(p.mx)
		rprintf("Magnetometer X-axis: %d \n", p.mx);
//	if(p.my)
		rprintf("Magnetometer Y-axis: %d \n", p.my);
//	if(p.mz)
		rprintf("Magnetometer Z-axis: %d \n", p.mz);

		rprintf("Altitude: %d \n", p.altitude);
		rprintf("Heading: %d \n", p.heading);

		rprintf("Servo data: %d, %d, %d, %d, %d, %d, %d, %d \n", servo[0], servo[1], servo[2], servo[3], servo[4], servo[5], servo[6], servo[7]);
		rprintf("Motor data: %d, %d, %d, %d, %d, %d, %d, %d \n", motors[0], motors[1], motors[2], motors[3], motors[4], motors[5], motors[6], motors[7]);
		rprintf("RC data: %d, %d, %d, %d, %d, %d, %d, %d \n", rcdata[0], rcdata[1], rcdata[2], rcdata[3], rcdata[4], rcdata[5], rcdata[6], rcdata[7]);
}
